/*
///////////////////////////////////////////////////////////////////////////////////////////////////
//shnQ ԊOvO
//	FileName	IR.c
//	Version		1.00
//	MCU		R8C/25 type:R5F21258,clock:20MHz(XIN clock)
//	Work		
//-------------------------------------------------------------------------------------------------
//
//
//	2008/06/19	Ver1.00

//-------------------------------------------------------------------------------------------------
//ldln
//	SW2,SW3ƐԊOMs܂B
	MɍsĂLCDɕ\܂B
	
	@\:SW,LCD,^C}[RD,INT,UART0M,UART0ݎM
//-------------------------------------------------------------------------------------------------
*/

/*

̃\tgEFA̓t[EFAłB

̃\tgEFAɊւ鎿ɂ܂ẮA
T|[g̑ΏۊOƂȂ܂B

쌠͍쐬ł()kldqL̂Ƃ܂B

̃\tgEFAgpƂɂSĂ̑QɂāA
쐬͈؂̐ӔC𕉂Ȃ̂Ƃ܂B

̃\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ
֎~܂BGȂǂ֏ЉE^̏ꍇ͘A肢v
܂B

  Copyright (C) Hokuto denshi Co,Ltd. 2008

*/

/*
/////////////////////////////////////////////////////////////////////////////////////////
//CN[ht@C錾
*/
#include "R8C25.h"

/*
/////////////////////////////////////////////////////////////////////////////////////////
//ϐ錾
*/
long msec;				/*҂*/
char rx_buffer[10];			/*Mf[^*/
unsigned char xcursor,ycursor,flag,a;


/*
/////////////////////////////////////////////////////////////////////////////////////////
//^錾
*/
#define VAL_LCD_ROW	16
#define VAL_LCD_COLUMN	2


/*
/////////////////////////////////////////////////////////////////////////////////////////
//}N錾
*/
#define LED1	P6.BIT.P_1	/*fobNpLED*/
#define LED2	P6.BIT.P_3
#define LED3	P2.BIT.P_6
#define LED4	P2.BIT.P_4
#define SW2	P1.BIT.P_7
#define SW3	P4.BIT.P_5
#define DB4	P0.BIT.P_5
#define DB5	P0.BIT.P_7
#define DB6	P0.BIT.P_3
#define DB7	P6.BIT.P_4
#define RS	P6.BIT.P_2
#define E	P0.BIT.P_1


/*
/////////////////////////////////////////////////////////////////////////////////////////
//֐vg^Cv錾
*/
void port_init(void);
void interrupt_init(void);
void serial_init(void);
void tx_cha(char tx);
void rx_str0(void);
void tx_str(char far *str);
int RD_init(void);
void wait(const long sec);
void wait_timer(const long msec2);
void timer_interrupt(void);
int LCD_init(void);
int LCD_clear(void);
int LCD_write(char lcddata);
int LCD_location(const unsigned char x,const unsigned char y);
int LCD_print(char far *lcdstr);
void int0_func(void);
void int1_func(void);

/*
///////////////////////////////////////////////////////////////////////////////
//Main program
*/
void main(void){
	char far *str1 = "Tiny I/O2\nIR test PROGRAM";
	char far *str2 = "SW2,SW3ø޻";
	xcursor = 0;
	ycursor = 0;
	flag=0;
	a=0;
	/*NbNݒ*/
	PRCR.BYTE = 0x01;		/*CM0,CM1,OCDɏ*/
	CM1.BIT.CM13 = 1;		/*XIN-XOUT [q*/
	CM0.BIT.CM05 = 0;		/*XINNbNU*/
	asm("NOP");			/*U莞Ԃ҂*/
	asm("NOP");
	asm("NOP");
	asm("NOP");
	OCD.BIT.OCD2 = 0;		/*XINNbNI*/
	
	port_init();
	interrupt_init();
	RD_init();
	asm("MOV.B	#05H,0137H");	/*TRD0 & TRD1̃JEgJn*/
	serial_init();
	LCD_init();
	LCD_location(0,0);
	LCD_print(str1);
	LCD_clear();
	LCD_print(str2);
	LCD_clear();
	wait_timer(500);
	while(1){

		a=0;
		rx_buffer[a] = '\0';		/*dummy*/
		if(flag == 2){
			flag=0;
			tx_str("IR demo");
		}
		else if(flag == 3){
			flag=0;
			tx_str("receiving");
		}
		LCD_location(0,0);
		LCD_print(rx_buffer);

		wait_timer(500);
		LCD_clear();
	}
}


/*|[g*/
void port_init(void){
	/**********o̓|[g**********/
	PRCR.BIT.PRC2 = 1;		/*PD0ɏ*/
	PD0.BYTE = 0xFF;		/*gpȂs͏o͂ɐݒ*/
	PD1.BYTE = 0x5F;
	PD2.BYTE = 0xFF;
	PD3.BYTE = 0x33;
	PD4.BYTE = 0xDC;
	PD6.BYTE = 0xFF;
	
	P0.BYTE = 0x00;
	P1.BYTE = 0x00;
	P2.BYTE = 0x5F;
	P3.BYTE = 0x00;
	P4.BYTE = 0x00;
	P6.BYTE = 0xFF;
}


/**/
void interrupt_init(void){
	/********** ݒ ***********/
	INTEN.BIT.INT0EN = 1;		/*INT0荞݂*/
	INTEN.BIT.INT1EN = 1;		/*INT1荞݂*/
	INTF.BYTE = 0x00;		/*tB^[*/ /*no filter*/
	#pragma ASM
	FCLR	I			;֎~,I=0
	MOV.B	#01H,005DH		;INT0IC register(SW3)	level 1
	MOV.B	#01H,0059H		;INT1IC register(SW2)	level 1
	MOV.B	#01H,0052H		;S0RIC register(UART0) level 1
	FSET	I			;,I=1
	#pragma ENDASM
}

/*********************************** interrupts functions ***********************************/
/**/
#pragma INTERRUPT int0_func
void int0_func(void){
	if(SW3 == 0){		/*SW3ꂽ*/
		flag = 3;
	}
}


#pragma INTERRUPT int1_func
void int1_func(void){
	if(SW2 == 0){		/*SW2ꂽ*/
		flag = 2;
	}
}


/* VA֐ ///////////////////////////////////////////////////////////*/
/*********************************** serial functions ***********************************/
/*VA (UART[h)*/
void serial_init(void){
	U0C1.BYTE = 0x00;		/*M֎~*/
	U0MR.BYTE = 0x05;		/*f[^8bit,STOPBIT=1,peB֎~*/
	U0C0.BYTE = 0x01;		/*f8,LSBI,CMOSo*/
	asm("MOV.B	#40H,00A1H");	/*1200bpsɐݒ*/
	U0C1.BIT.TE = 1;		/**M*/
	U0C1.BIT.RE = 1;		/*M*/
}



/*ꕶM*/
void tx_cha(char tx){
	asm("PUSH.B	R0L");		/*ޔ*/
  	asm("MOV.B	$$[FB],R0L",tx);/*txR0Lɑ*/
  	asm("MOV.B	R0L, 00A2H");	/*txU0TBɑ*/
	while(!(U0C1.BIT.TI == 1));	/*U0TBWX^ɂȂ܂Ń[v*/
 	asm("POP.B	R0L");		/*A*/
}

/*VAM*/
void tx_str(char far *str){
	while(*str != '\0'){		/*'\0'܂tx_cha֐ɓn*/
		tx_cha(*str++);
	}
	tx_cha(*str);		/*Ō'\0'𑗐M*/
}

/*VAM*/
#pragma INTERRUPT rx_str0
void rx_str0(void){
	short rxdata = 0;	/*l̓_~[*/
	while(U0C1.BIT.RI == 1){	/*U0RBWX^ǂނRI0ɂȂ*/
		asm("PUSH.W	R1");	/*ޔ*/
		asm("MOV.W	00A6H,R1");	/*U0RBWX^16rbgPʂœǂݏo*/
		asm("MOV.W	R1,$$[FB]",rxdata);/*U0RBWX^̒lrxdataɑ*/
		asm("POP.W	R1");		/*A*/
		rx_buffer[a] = (char)(rxdata & 0x00FF);
		(int)a++;
		rx_buffer[a] = '\0';
	}
}



/* ^C}[֐ ///////////////////////////////////////////////////////////*/
/*********************************** timer functions ***********************************/
/*^C}[ݒ*/
int RD_init(void){
	/*ʐݒ*/
	TRDMR.BYTE = 0x00;		/*TRDGRC/DWX^WFlWX^ƂĎgp*/
	TRDFCR.BIT.PWM3 = 1;
	TRDFCR.BIT.CMD0 = 0;
	TRDFCR.BIT.CMD1 = 0;
	
	/*chanel0*/			/*PWM[h*/
	TRDOER1.BIT.ED0 = 0;		/*o͋*/
	TRDCR0.BYTE = 0x21;		/*TRDGRDOŃRyAv,f2*/
	TRDPMR.BIT.PWMD0 = 1;		/*PWM[h*/
	TRDIER0.BYTE = 0x00;		/*֎~*/
	TRDOCR.BIT.TOD0 = 0;		/*o͂̓ANeBułȂx*/
	TRDPOCR0.BIT.POLD = 1;		/*TRDIODȉo̓x'H'*/

	TRDGRA0.WORD = 262;		/*F38kHz*/
	TRDGRD0.WORD = 131;		/*f[eBF50%*/
	
	/*chanel1*/			/*AEgvbgRyA,^C}[荞*/
	TRDCR1.BYTE = 0x24;		/*TRDGRA1ŃRyAv,f32*/
	TRDPMR.BIT.PWMB1 = 0;		/*^C}[[h*/
	TRDIER1.BYTE = 0x01;		/*IMIA*/
	TRDIORA1.BYTE = 0x08;		/*RyAvŏo͋֎~*/
	TRDGRA1.WORD = 0x0270;		/*1msec*/
}


void wait_timer(const long msec2){
	asm("FCLR	I");		/*֎~,I=0*/
	asm("MOV.B	#01H,0049H");	/*TRD1IC register(wait_timer),level1*/
	asm("FSET	I");		/*,I=1*/
	msec = msec2;
	asm("OR.B	#0AH,0137H");	/*JEgJn*/
	while(msec != 0);
	asm("AND.B	#0DH,0137H");	/*JEg~*/
}



/**/
#pragma INTERRUPT timer_interrupt
void timer_interrupt(void){
	if(msec != 0){
		msec = (msec-1);
	}
	TRDSR1.BIT.IMFA = 0;		/*̊֐݂̂Őݒ*/
}



/*ԑ҂[v*/
void wait(const long sec){
	volatile long k;
	for(k=0; k<200*sec; k++);
}

/* LCD֐ ///////////////////////////////////////////////////////////*/
/*********************************** LCD functions ***********************************/
/*LCD*/
int LCD_init(void){
	wait(20);
	RS = 0;
	/*LCD1*/
	E = 1;
	DB4 = 1;		/*MM1*/
	DB5 = 1;
	DB6 = 0;
	DB7 = 0;
	wait(1);
	E = 0;
	wait(1);
	wait(5);
	
	/*LCD2*/
	E = 1;
	DB4 = 1;		/*MM2*/
	DB5 = 1;
	DB6 = 0;
	DB7 = 0;
	wait(1);
	E = 0;
	wait(1);

	/*LCD3*/
	E = 1;
	DB4 = 1;		/*MM3*/
	DB5 = 1;
	DB6 = 0;
	DB7 = 0;
	wait(1);
	E = 0;
	wait(1);
	
	/*LCD4*/
	E = 1;
	DB4 = 0;		/*MM4*/
	DB5 = 1;
	DB6 = 0;
	DB7 = 0;
	wait(1);
	E = 0;
	wait(1);
	
	LCD_clear();
	
	/*t@NVZbg  4bit(DL=0),2s(N=0),5x7tHg(F=0)*/
	LCD_write(0x28/*0x20 + 0x08*/);

	/*Gg[[h  \VtgȂ(S=0),CNg(I/O=1)*/
	LCD_write(0x06/*0x04 + 0x02*/);

	/*J[\/\Vtg  J[\ړ(S/C=0),Vtg(R/L=0)*/
	LCD_write(0x10);

	/*\ON/OFFRg[  S\(D=1),J[\:ON(C=1),uN:ON(B=1)*/
	LCD_write(0x0D/*0x08 + 0x04 + 0x01*/);
	
	
	LCD_clear();
	wait(5);
	return 0;
}
/*\NA*/
int LCD_clear(void){
	RS = 0;
	LCD_write(0x01);
	wait(2);
	LCD_location(0,0);
	return 0;
}

/**/
int LCD_write(char lcddata){
	/*4bit*/
	E = 1;
	DB4 = (( lcddata >> 4 ) & 0x01);
	DB5 = (( lcddata >> 5 ) & 0x01);
	DB6 = (( lcddata >> 6 ) & 0x01);
	DB7 = (( lcddata >> 7 ) & 0x01);
	wait(1);
	E = 0;
	wait(1);
	/*4bit*/
	E = 1;
	DB4 = ( lcddata & 0x01);
	DB5 = (( lcddata >> 1 ) & 0x01);
	DB6 = (( lcddata >> 2 ) & 0x01);
	DB7 = (( lcddata >> 3 ) & 0x01);
	wait(1);
	E = 0;
	wait(1);
	return 0;
}

/*J[\ړ*/
int LCD_location(const unsigned char x,const unsigned char y){
	unsigned char addressdata;
	addressdata = ( (y * 0x40) + x );
	addressdata = (addressdata | 0x80);		/*DRAMAhXݒDB7͐M*/
	RS = 0;
	LCD_write(addressdata);
	wait(1);

	xcursor = x;					/*J[\ۑ*/
	ycursor = y;
	return 0;
}

/*\*/
int LCD_print(char far *lcdstr){
	unsigned char n=0,j;
	/* \[v */
	for(n=0; lcdstr[n] != '\0'; n++){
		/*`*/
		if((lcdstr[n] >= 0x20 && lcdstr[n] <= 0x7f) || (lcdstr[n] >= 0xa1 && lcdstr[n] <= 0xfd)){
			/*LCDR[h͈͓̔̏ꍇ*/
			/*`*/
			RS = 1;
			LCD_write(lcdstr[n]);
			wait(1);
				/*J[\ړ*/
				if(xcursor == (VAL_LCD_ROW - 1)){	/*16sI[o[ꍇ(15,0)1̂҂*/
					
					xcursor = 0;
					ycursor = (ycursor == 0 ? 1 : 0);	/*(0,1)珑*/
					LCD_location(xcursor,ycursor);
					for(j=0; j < VAL_LCD_ROW; ++j){
						RS = 1;
						LCD_write(' ');
					}
					LCD_location(xcursor,ycursor);
				}
				else{					/*16sȓ̏ꍇ*/
					++xcursor;
					LCD_location(xcursor,ycursor);
				}
		}
		else if( lcdstr[n] == '\n' ){			/*sR[h̏ꍇ*/
			xcursor = 0;
			ycursor = (ycursor == 0 ? 1 : 0);	/*y0*/
			LCD_location(xcursor,ycursor);
			for(j=0; j < 16; ++j){
				RS = 1;
				LCD_write(' ');
			}
			LCD_location(xcursor,ycursor);
		}
		else {	/*LCDR[h͈̔͊Ȍꍇ*/
		/* if ( ( lcdstr[n] >= 0x21 && lcdstr[n] <= 0x7f ) || ( lcdstr[n] >= 0xa1 && lcdstr[n] <= 0xfd ) )*/
		}
	}
	return 0;
}



